% Advanced Signal Processing Seminar
% Manuel forrer, Markus Froehle
%
% Noise Cancellation with LMS, RLS, NLMS
%
% y1 ... Recording from the bottom of the elevator shaft
% y2 ... Recording from the elevator engine

clear all;
close all;

load recordings

%% disturbed signal of interest
soundsc(y1,fs)

%% disturbance
soundsc(y2,fs)

%% LMS
N = 5;          % Model order
muu = 0.25;      % step size

[thetahat, xhat] = lms(y1,y2,N,muu);
soundsc(y1-xhat,fs)



%% RLS

N = 5;           % Dimension of the parameter vector
lambda = 0.980;  % Forgetting factor

[thetahat,xhat] = rls(y1,y2,N,lambda);
soundsc(y1-xhat,fs)


%% NLMS
N = 5;          % Model order
muu = 0.9;     % step size

[thetahat, xhat] = nlms(y1,y2,N,muu);
soundsc(y1-xhat,fs)

