% ICA Presentation
% DI (FH) Pfeifenberger Lukas
% 29-11-2009


clear all
close all
clc


%number of samples
N = 5e3;

%generate some input data

%this one is supergaussian
s(1,:) = randlap([1 N],1);
%this one is subgaussian
s(2,:) = sin((1:N)/100);


%subtract mean
s = s - repmat(mean(s')',[1 N]);


%mixing matrix
A = [[2 -5]; -[1 2]];
%mixed signals x
x = A*s;


%sphering matrix
[E,D] = eig(cov(x'));
V = E*D^-0.5*E';
x = V*x;



figure('Position',[200,0,200+800,0+900]);


for i = 1:50+90
    alpha(i) = (i-1)-90;
    W(:,:,i) = [cos(alpha(i)*pi/180), -sin(alpha(i)*pi/180);
                sin(alpha(i)*pi/180),  cos(alpha(i)*pi/180)];

    y = W(:,:,i)*x;
    k(i,:) = mean(y'.^4)-3*mean(y'.^2).^2;
    kabs(i) = sum(abs(k(i,:)));




subplot(3,2,2)
hold on
plot(alpha,k(:,1),'b')
plot(alpha,k(:,2),'r')
plot(alpha,kabs,'g','LineWidth',2)
hold off
grid on
axis([-90 51 -2 6])
title('kurtosis')

subplot(3,2,3)
y1 = y(1,:);
y2 = y(2,:);
plot(y1,y2,'g.')
grid on
axis([-6 6 -4 4])
title('joint pdf of y1 and y2')

subplot(3,2,1)
[hist1, pos1] = hist(y1, [-6:12/20:6]);
bar(pos1,hist1, 'b');
grid on;
axis([-6 6 0 1500])
title('hist of y1')

subplot(3,2,4)
[hist1, pos1] = hist(y2, [-4:8/15:4]);
barh(pos1,hist1, 'r');
grid on;
axis([0 1500 -4 4])
title('hist of y2')

subplot(3,2,5)
hold
plot(y(1,:),'b')
axis([1 N -5 5])
title('ic 1')

subplot(3,2,6)
hold
plot(y(2,:),'r')
axis([1 N -5 5])
title('ic 2')

drawnow

end

break


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



[v i] = max(kabs);
Wopt = W(:,:,i);

%calc reconstructed data y
y = Wopt*x;


%[A W] = fastica(x,'displayMode','on');
%break


