% ICA Presentation
% DI (FH) Pfeifenberger Lukas
% 30-11-2009

clear all
close all
clc


%samples
N = 1e3;
%independent vars
M = 3;


%generate some input

%not nice
s(1,:) = randn(1,N) + randlap([1 N],1)/100;
%this is definitely not nice
s(2,:) = randn(1,N);
%this one is sub-gaussian
s(3,:) = tan(cos((1:N)/N*20));


%subtract mean
s = s - repmat(mean(s')',[1 N]);


%mixing matrix
A = rand(M);
%mixed signals x
x = A*s;



%[A W] = fastica(x);
W = kernel_ica_options(x,'contrasttype','oneunit','ncomp',M, ...
                       'W0',rand_orth(M),'contrast','kgv', ...
                       'kernel','hermite','sig',1.5,'kap',.0001, ...
                       'p',3,'polish',1,'restarts',4,'disp',0);
W = kernel_ica_options(x,'W0',W,'contrast','kgv','kernel','gaussian', ...
                       'sig',.5,'kap',.001,'p',4,'polish',0, ...
                       'restarts',1,'disp',0);

%unmix x
y = W*x;


%kurtosis check
ks = mean(s'.^4)-3*mean(s'.^2).^2
kx = mean(x'.^4)-3*mean(x'.^2).^2
ky = mean(y'.^4)-3*mean(y'.^2).^2




for i=1:M
subplot(3,M,i)
plot(s(i,:))
title(sprintf('source s%d',i));
axis off;

subplot(3,M,i+M)
plot(x(i,:))
title(sprintf('mixture x%d',i));
axis off;

subplot(3,M,i+2*M)
plot(y(i,:))
title(sprintf('estimate y%d',i));
axis off;

end


