function [X, SigmaEst, MuEst] = GenerateCluster(N, Sigma, Mu, type)

    if (strcmp(type,'gaussian'))
        X_in(:, 1) = randn(N, 1);
        X_in(:, 2) = randn(N, 1);
    elseif(strcmp(type, 'uniform'))
        X_in(:, 1) = (rand(N, 1)-0.5)*2;
        X_in(:, 2) = (rand(N, 1)-0.5)*2;
    elseif(strcmp(type, 'multi'))
        X_in(:, 1) = [-3 + randn(N/2, 1); 3 + randn(N/2, 1)];
        X_in(:, 2) = [-3 + randn(N/2, 1); 3 + randn(N/2, 1)];
    end

    X = X_in*Sigma^(0.5) + repmat(Mu, N, 1);

    
    MuEst = mean(X, 1);
    Xh = X-repmat(MuEst, N, 1);
    SigmaEst = Xh'*Xh / (N - 1);

end