%% Settings
clear all;
close all;
addpath('stprtool');
stprpath('stprtool');

%% Start sample 1
fprintf('\nStart sample 1\n\n');

% Load the data
trn = load('stprtool/data/riply_data/riply_trn.mat');
% trn.X = randn(2, 150) + repmat([-5; 3], 1, 150);
% trn.X = [trn.X, randn(2, 150) + repmat([5; 3], 1, 150)];
% trn.X = [trn.X, randn(2, 300)];
% trn.name = 'hallo';
% trn.y = ones(1, 300);
% trn.y = [trn.y, 2 * ones(1, 300)];
% trn.dim = 2;
% trn.num_data = 600;

% Plot the data
figure;
ppatterns(trn);
title('Input data');
ylabel('x_1');
xlabel('x_2');
grid on;

% Define the kernel
% Linear
%kernel_type = 'linear';
%kernel_arg = [];
% Radial Basis Function
kernel_type = 'rbf';
kernel_arg = 1;
% Polynomial
%kernel_type = 'poly';
%kernel_arg = [4, 1];
% Sigmoid
%kernel_type = 'sigmoid';
%kernel_arg = [2, 1];
options = struct('ker', kernel_type, 'arg', kernel_arg, 'C', 10, 'mu', 0.001);

% Calculate the kernel matrix
K = kernel(trn.X, kernel_type, kernel_arg);

% Apply Kernel Fisher Discriminant
model = kfd(trn, options);

% Plot the discrimating function
figure;
ppatterns(trn);
psvm(model);
title('Discriminate function, (SVs)');
ylabel('x_1');
xlabel('x_2');
grid on;

% Display the training error
fprintf('Training error: %f\n', model.trnerr);

% Project each training sample onto the discriminate function
X1 = trn.X(:, trn.y == 1);
X2 = trn.X(:, trn.y == 2);
x1_projected = zeros(size(X1, 2), 1);
x2_projected = zeros(size(X2, 2), 1);
for i=find(trn.y == 1)
    x1_projected(i) = model.Alpha'*K(:, i);
end
x2_ind = 1;
for i=find(trn.y == 2)
    x2_projected(x2_ind) = model.Alpha'*K(:, i);
    x2_ind = x2_ind + 1;
end

start_bin = floor(min([x1_projected; x2_projected]));
end_bin = ceil(max([x1_projected; x2_projected]));
bin_range = start_bin:0.1:end_bin;
[N1, C1] = hist(x1_projected, bin_range);
[N2, C2] = hist(x2_projected, bin_range);

figure;
bar(bin_range, N1, 'b'); hold on;
bar(bin_range, N2, 'r');
stem(-model.b,100);
grid on;
title('distribution of data points projected on w');
