clear all;
close all;

N1 = 1000;
N2 = 1000;

S1 = [  1,          0;
        0,          1];
     
S2 = [  2,          -0.7;
        -0.7,       5];
     
S3 = [  4,          0.8;
        0.8,        2];
    
alpha = pi/3;
S4 = [  cos(alpha), -sin(alpha);
        sin(alpha), cos(alpha)];
    
Sigma1 = S2;
Sigma2 = S3;
     
     
Mu1 =    [0,     0];
Mu2 =    [7,     3];
     

[X1, SigmaEst1, MuEst1] = GenerateCluster(N1, Sigma1, Mu1, 'gaussian');
[X2, SigmaEst2, MuEst2] = GenerateCluster(N2, Sigma2, Mu2, 'gaussian');

X1_h = X1 - repmat(MuEst1, N1, 1);
X2_h = X2 - repmat(MuEst2, N2, 1);

Sw = SigmaEst1 + SigmaEst2;



w_lda = inv(Sw)*(MuEst2 - MuEst1)';
w_lda = w_lda / norm(w_lda);

%Calculate Optimal Values
%Sw_opt = Sigma1 + Sigma2;
%w_lda_opt = inv(Sw_opt) * (Mu2 - Mu1)';
%w_lda_opt = w_lda_opt / norm(w_lda_opt);

decisionThreshold = w_lda' * (Mu1 + Mu2)' / 2;

%% Compute drawable Discriminant functions

%check drawing window
maxSigma = max(max(abs([SigmaEst1, SigmaEst2])));

maxX = max([X1(:, 1); X2(:, 1)]);
minX = min([X1(:, 1); X2(:, 1)]);
maxY = max([X1(:, 2); X2(:, 2)]);
minY = min([X1(:, 2); X2(:, 2)]);

x = minX:maxX;
y = decisionThreshold / w_lda(2) - w_lda(1)/w_lda(2) .*x;

validIndex = (y<maxY) & (y>minY);

x = x(validIndex);
y = y(validIndex);

%Add w to the last point of the discriminant function
w_line(:, 1) = [x(end); y(end)] - w_lda*10;
w_line(:, 2) = [x(end); y(end)] + w_lda*10;


figure;
scatter(X1(:, 1), X1(:, 2), 'r');hold on;
scatter(X2(:, 1), X2(:, 2), 'b+');hold on;
pbaspect([1,1,1]);
daspect([1,1,1]);



b = plot(w_line(1, :), w_line(2, :), 'k:'); hold on;
set(b, 'linewidth', 2, 'color', 'black');
b = plot(x, y, 'k:');
set(b, 'linewidth', 2, 'color', 'black');
hold off;
 
grid on;
xlabel('X1');
ylabel('X2');
legend('Class 1', 'Class 2');

X1T = w_lda'*X1';
X2T = w_lda'*X2';

figure;
[histX1, Pos1] = hist(X1T, 20);
[histX2, Pos2] = hist(X2T, 20);
grid on;

maxFrequency = max([histX1, histX2]);

bar(Pos1, histX1, 'r'); hold on;
bar(Pos2, histX2, 'b'); hold on;
stem(decisionThreshold, maxFrequency*1.3); hold off;







